# -*- coding: utf-8 -*-

import numpy as np
import scipy.stats as stat
import scipy.cluster as cluster

import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/Informatique/Python/Slides/exemples/I")

#loading the data matrix
M = np.loadtxt("datacluster.txt",delimiter="\t",dtype=float)
np.std(M,axis=0)

#scatter plot
import matplotlib.pyplot as plt
plt.plot(M[:,0],M[:,1],"ko")

#standardization
#axis=0, calculation on rows for each column
#ddof = 0, using 1/(n-0) for the calculation of the variance
Z = stat.zscore(M,axis=0,ddof=0)
np.std(Z,axis=0)

#k-means into 3 groups
centroid,label = cluster.vq.kmeans2(Z,k=3)
#centroid of groups
print(centroid)
#group membership for each instances
print(label)

#graphical representation of groups
plt.plot(M[label==0,0],M[label==0,1],"bo",
         M[label==1,0],M[label==1,1],"ro",
         M[label==2,0],M[label==2,1],"go")
        
#HAC

#Ward's method
W = cluster.hierarchy.ward(Z)

#displaying the dendrogram
cluster.hierarchy.dendrogram(W)

#cut at the level t=4
idx = cluster.hierarchy.fcluster(W,t=4,criterion="distance")

#graphical representation again
plt.plot(M[idx==1,0],M[idx==1,1],"bo",
         M[idx==2,0],M[idx==2,1],"ro",
         M[idx==3,0],M[idx==3,1],"go")
         